import { IMaterializeOnlineOptions } from './types';
/**
 * 创建组件包
 *
 * @private
 * @param {{
 *     pkgName: string;
 *     pkgVersion: string;
 *   }} params
 * @returns {Promise<void>}
 * @memberof OnlineAccesser
 */
export declare function createFakePackage(params: {
    workDir: string;
    pkgName: string;
    pkgVersion: string;
    npmClient?: string;
}): Promise<void>;
/**
 * 创建临时目录
 *
 * @private
 * @returns {Promise<string>} 返回临时文件夹路径
 * @memberof LocalGenerator
 */
export declare function createworkDir(tempDir?: string): Promise<string>;
/**
 * 分离物料组件名称和版本号
 *
 * @private
 * @param {string} pkgNameWithVersion
 * @returns {{ [key: string]: any }}
 * @memberof OnlineAccesser
 */
export declare function getPkgNameAndVersion(pkgNameWithVersion: string): {
    [key: string]: any;
};
export default function localize(options: IMaterializeOnlineOptions): Promise<{
    workDir: string;
    moduleDir: string;
    entry?: string;
}>;
