"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const transform_1 = require("../transform");
const utils_1 = require("../../utils");
const resolver_1 = tslib_1.__importDefault(require("./resolver"));
const handlers_1 = tslib_1.__importDefault(require("./handlers"));
const reactDocs = require('react-docgen');
function parse(filePath) {
    if (!filePath)
        return [];
    const fileContent = utils_1.loadFile(filePath);
    const result = reactDocs.parse(fileContent, (ast) => {
        ast.__path = filePath;
        return resolver_1.default(ast);
    }, handlers_1.default, {
        filename: filePath,
    });
    const coms = result.reduce((res, info) => {
        if (!info || !info.props)
            return res;
        const props = Object.keys(info.props).reduce((acc, name) => {
            try {
                const item = transform_1.transformItem(name, info.props[name]);
                acc.push(item);
            }
            catch (e) {
                // TODO
            }
            return acc;
        }, []);
        res.push({
            componentName: info.displayName,
            props,
            meta: info.meta || {},
        });
        return res;
    }, []);
    return coms;
}
exports.default = parse;
//# sourceMappingURL=index.js.map