"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const ast_types_1 = require("ast-types");
const { isReactCreateClassCall, isReactForwardRefCall } = require('react-docgen').utils;
/**
 * If the path is a call expression, it recursively resolves to the
 * rightmost argument, stopping if it finds a React.createClass call expression
 *
 * Else the path itself is returned.
 */
function resolveHOC(path) {
    const { node } = path;
    if (ast_types_1.namedTypes.CallExpression.check(node) &&
        !isReactCreateClassCall(path) &&
        !isReactForwardRefCall(path)) {
        if (node.arguments.length) {
            const inner = path.get('arguments', 0);
            // If the first argument is one of these types then the component might be the last argument
            // If there are all identifiers then we cannot figure out exactly and have to assume it is the first
            if (node.arguments.length > 1 &&
                (ast_types_1.namedTypes.Literal.check(inner.node) ||
                    ast_types_1.namedTypes.ObjectExpression.check(inner.node) ||
                    ast_types_1.namedTypes.ArrayExpression.check(inner.node) ||
                    ast_types_1.namedTypes.SpreadElement.check(inner.node))) {
                return resolveHOC(
                // resolveToValue(path.get('arguments', node.arguments.length - 1)),
                path.get('arguments', node.arguments.length - 1));
            }
            // return resolveHOC(resolveToValue(inner));
            return resolveHOC(inner);
        }
    }
    return path;
}
exports.default = resolveHOC;
//# sourceMappingURL=resolveHOC.js.map