"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const checkIsIIFE_1 = tslib_1.__importDefault(require("./checkIsIIFE"));
const resolveFunctionDefinitionToReturnValue = require('react-docgen/dist/utils/resolveFunctionDefinitionToReturnValue')
    .default;
/**
 * If the path is a call expression, it recursively resolves to the
 * rightmost argument, stopping if it finds a React.createClass call expression
 *
 * Else the path itself is returned.
 */
function resolveIIFE(path) {
    if (!checkIsIIFE_1.default(path)) {
        return path;
    }
    const returnValue = resolveFunctionDefinitionToReturnValue(path.get('callee'));
    return returnValue;
}
exports.default = resolveIIFE;
//# sourceMappingURL=resolveIIFE.js.map